=== examples/subcom_in_files/CMakeLists.txt ===
add_cli_exe(subcommand_main subcommand_main.cpp subcommand_a.cpp subcommand_a.hpp)
