=== debian/changelog ===
cli11 (2.5.0+ds-1) unstable; urgency=medium

  * New upstream version 2.5.0+ds
  * Migrate d/watch to v5
  * Bump policy to 4.7.2, no changes

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 12 Sep 2025 09:32:07 +0000
