=== debian/control ===
Source: cli11
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: libdevel
Priority: optional
Build-Depends: debhelper-compat (= 13),
               catch2,
               cmake,
               doxygen
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/jrivero-guest/cli11
Vcs-Git: https://salsa.debian.org/jrivero-guest/cli11.git
Rules-Requires-Root: no
Homepage: https://github.com/CLIUtils/CLI11

Package: libcli11-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Command line parser for C++11 and beyond
 CLI11 provides all the features you expect in a powerful command line
 parser, with a beautiful, minimal syntax and no dependencies beyond
 C++11. It is header only, and comes in a single file form for easy
 inclusion in projects.
 .
 This package contains cli11 headers and developments artifacts

Package: libcli11-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Command line parser for C++11 and beyond - Documentation
 CLI11 provides all the features you expect in a powerful command line
 parser, with a beautiful, minimal syntax and no dependencies beyond
 C++11. It is header only, and comes in a single file form for easy
 inclusion in projects.
 .
 This package gathers cli11 documentation and source code examples
