## cli11 2.6.1+ds

=== debian/changelog ===
cli11 (2.6.1+ds-1) unstable; urgency=medium

  * New upstream version 2.6.1+ds
  * Update copyright

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 23 Dec 2025 19:59:50 +0000
